% $Id: medizin-kosten.pl,v 1.2 1995/12/06 10:41:54 uwe Exp $ 
%  Kostenfuntionen und Heuristiken fuer Wasserkrug 

:- assertz((help :-
	write('Kostenfunktionen und Heuristiken fuer das Medizinmischen'), nl,
	write('  breitensuche.	-> g(n) =  1, h(n) = 0'), nl,
	write('  tiefensuche.	-> g(n) = -1, h(n) = 0'), nl,
        write('  bestensuche.	-> g(n) =  0, h(n) = Abstand zu 2l im 4-er Krug'), nl,
	write('  wasserkosten.	-> g(n) =  wassermenge, h(n) = 0'), nl,
	write('Voreinstellung: breitensuche'), nl,
	nl, fail)
	).

bestensuche :-
	kostenkonstant(0),
        setrule(guess(_,_),
                (guess((W : _) :-> _, C) :-
			abstand(W,1/3+5/3,C))
        ).

wasserkosten :-
	setrule(pathcost(_,_,_),
		(pathcost(O :-> _, N :->  _, C) :-
			wasser(O, N, C)
		)
	),
	keineheuristik.

%-------------------------------------------------------------------------------------

abstand(S+W,SZ+WZ,C) :-
	!,
	abstand(S,SZ,DS),
	abstand(W,WZ,DW),
	D := DS + DW,
	numerator(D,Num),
	denominator(D,Den),
	C is (Num * 1000) // Den.

abstand(I, J, K) :-
	J gr I,
	!,
	K := J - I.

abstand(I, J, K) :-
	K := I - J.

wasser(_ + O4 : _ + O1, _ + N4 : _ + N1, W) :-
	O := O4 + O1,
	N := N4 + N1,
	N gr O,
	!,
	W := N - O.

wasser(_, _, 0).

%-------------------------------------------------------------------------------------

