% $Id: medizin-regeln.pl,v 1.1 1995/11/29 16:00:59 uwe Exp $ 

:- assertz(
	(help :-
		write('Medizin mischen:'), nl,
		write('Geraete und Material:'), nl,
		write('   ein 4-l Krug und ein 1-l Krug ohne Mass'), nl,
		write('   ein Wasserhahn und ein Ausguss'), nl,
		write('   ein Liter Saft'), nl,
		write('Ziel ist es, 2 Liter Medizin (Saft und Wasser)'), nl,
		write('   im Verhaeltnis 1:5 zu mischen'), nl,
		write('Zustaende haben die Form s4+w4:s1+w1'), nl,
		write('   wobei die Zahlen Brueche sein koennen'), nl,
		nl, fail)
	).

:- op(700, xfx, [ :=, gr, ge, eq ] ).

:- consult('rat').

:- op(990,xfx,:).

rule(S4+_:S1+_, _) :-		% nicht mehr genug Saft 
	S := S4 + S1,
	1/3 gr S,
	!,fail.

rule('4-er Krug mit Wasser fuellen', S4+W4:Y, S4+W:Y) :-
	F4 := S4 + W4,
	4 gr F4,
	DeltaW  := 4 - F4,
	W       := DeltaW + W4.

rule('1-er Krug mit Wasser fuellen', X:S1+W1, X:S1+W) :-
	F1 := S1 + W1,
	1 gr F1,
	DeltaW  := 1 - F1,
	W       := DeltaW + W1.

rule('4-er Krug leeren', S4+W4:Y, 0+0:Y) :-
	F4 := S4+W4,
	F4 gr 0.

rule('1-er Krug leeren', X:S1+W1, X:0+0) :-
	F1 := S1+W1,
	F1 gr 0.

rule('4-er Krug aus 1-er Krug voll fuellen', S4+W4:S1+W1, S4neu+W4neu:S1neu+W1neu) :-
	F4 := S4+W4,
	4 gr F4,
	F1 := S1+W1,
	F  := F4+F1,
	F ge 4,
	Delta4 := 4 - F4,
	DeltaS  := S1 * Delta4,
	DeltaW  := W1 * Delta4,
	DeltaS1 := DeltaS / F1,
	DeltaW1 := DeltaW / F1,
	S4neu   := S4 + DeltaS1,
	W4neu   := W4 + DeltaW1,
	S1neu   := S1 - DeltaS1,
	W1neu   := W1 - DeltaW1.

rule('1-er Krug aus 4-er Krug voll fuellen', S4+W4:S1+W1, S4neu+W4neu:S1neu+W1neu) :-
	F1 := S1+W1,
	1 gr F1,
	F4 := S4+W4,
	F  := F1+F4,
	F ge 1,
	Delta1 := 1 - F1,
	DeltaS  := S4 * Delta1,
	DeltaW  := W4 * Delta1,
	DeltaS4 := DeltaS / F4,
	DeltaW4 := DeltaW / F4 ,
	S1neu   := S1 + DeltaS4,
	W1neu   := W1 + DeltaW4,
	S4neu   := S4 - DeltaS4,
	W4neu   := W4 - DeltaW4.

rule('1-er Krug in 4-er Krug leeren', S4+W4:S1+W1, S4neu+W4neu:0+0) :-
	F1 := S1+W1,
	F1 gr 0,
	F4 := S4+W4,
	F  := F4+F1,
	4 ge F,
	S4neu   := S4 + S1,
	W4neu   := W4 + W1.

rule('4-er Krug in 1-er Krug leeren', S4+W4:S1+W1, 0+0:S1neu+W1neu) :-
	F4 := S4+W4,
	F4 gr 0,
	F1 := S1+W1,
	F  := F1+F4,
	1 ge F,
	S1neu   := S1 + S4,
	W1neu   := W1 + W4.

solution(1/3+5/3:_). 

outstate(S) :- 
	write(S).
outrule(R) :-
	write('	--> ('),
	write(R),
	write(')'),
	nl.

%-------------------------------------------------------------------------------------
