% $Id: mug6.pl,v 1.1 1995/11/29 16:01:02 uwe Exp $ 
% Breitensuche in einem Graph           
% schon besuchte Knoten werden nicht    
% wieder beruecksichtigt                
% solve erhaelt die Menge der schon     
% besuchten Knoten als zusaetzlichen    
% Parameter                             
% ohne Erklaerungskomponente            

:-op(200,xfx,:).

rule(X:Y, 4:Y) :- 
	X < 4.
rule(X:Y, X:3) :- 
	Y < 3.
rule(X:Y, 0:Y) :- 
	X > 0.
rule(X:Y, X:0) :- 
	Y > 0.
rule(X:Y, 4:Z) :- 
	X < 4, X + Y >= 4, 
	Z is X + Y - 4.
rule(X:Y, Z:3) :- 
	Y < 3, X + Y >= 3, 
	Z is X + Y - 3.
rule(X:Y, Z:0) :-
	Y > 0, X + Y < 4, 
	Z is X + Y.
rule(X:Y, 0:Z) :-
	X > 0, X + Y < 3, 
	Z is X + Y.
    
    % generiere alle Nachfolger aus einem Knoten 
  
gen1(S,L) :-
	findall(S1,rule(S,S1),L).

    % generiere alle Nachfolger aus einer Liste 
gen([],[]).
gen([S|T],Succ) :- 
	gen1(S,Succ1), 
	gen(T,  Succ2), 
	union(Succ1,Succ2,Succ).
  
    % union(S1,S2,S1 u S2) 

union([],S,S).
union([H|T],S2,S) :- 
	isin(H,S2),
	!,
	union(T,S2,S).
union([H|T],S2,[H|S]) :- 
	union(T,S2,S).
    
    % minus(S1,S2,S1 - S2) 

minus(S1,[],S1).
minus(S1,[H|S2],S3) :- 
	minus1(H,S1,S4),
	minus(S4,S2,S3).
minus1(_,[],[]).
minus1(E,[H|T],   S ) :- 
	E=H, 
	!, 
	minus1(E,T,S).
minus1(E,[H|T],[H|S]) :-         
	minus1(E,T,S). 

isin(S,[H|_]) :- 
	S = H,
	!.
isin(S,[_|T]) :- 
	isin(S,T).

solve(Statelist,G,N,_,_) :- 
	isin(G,Statelist), 
	!, 
	write('Loesung im '),write(N),write('. Schritt'),nl.

solve(_,_,Max,Max,_) :- 
	!, fail.
  
solve(Statelist,G,N,Max,Visited) :- 
	gen(Statelist,Succ), 
	union(Visited,Statelist,Newvisited), 
	minus(Succ,Newvisited,Newsucc), 
	N1 is N + 1, 
	write(N1),write('. Schritt:'),nl,
	write(Newsucc),nl, 
	solve(Newsucc,G,N1,Max,Newvisited).

zweiliter(Max) :- 
	solve([0:0], 2:_, 0, Max, []), 
	!.
zweiliter(Max) :- 
	write('Keine Loesung in '),write(Max),
	write(' Schritten moeglich'),nl.

zweiliter :-
	zweiliter(7).
