% $Id: mult-breit.pl,v 1.2 1996/12/12 07:55:20 uwe Exp $ 

%--- Zerlegung einer Multiplikation in ADD, SUB und SHIFT sequenzen ------------------

:- asserta(
	(help :-
		write('Zerlegung von Multiplikationen mit Konstanten in Sequenzen'), nl,
		write('von ADD, SUB, SHIFT und LEA-Instruktionen'), nl,
		write('durch Breitensuche'), nl,
		write('zur Optimierung von Ausdruecken "c * v"'), nl,
		write('Annahme: v steht in einem Register r0, c > 0'), nl,
		write('Ziele:'), nl,
		write('   zerlege(C).'), nl,
		write('   zerlege. (einige Beispiele)'), nl,
		write('   leaon.   (ohne LEA Instruktionen)'), nl,
		write('   leaoff.  (mit  LEA Instruktionen)'), nl,
		nl, fail)
	).

:- consult('breitensuche').
:- reverseon.

:- consult('mult-regeln').
:- consult('listfct').

:- assertz((help :- true)).
:- help.

    % no LEA instructions 
:- assert(machinepowers([])).

leaon :-
	retractall(machinepowers(_)),
	assert(machinepowers([1,2,3])).
leaoff :-
	retractall(machinepowers(_)),
	assert(machinepowers([])).

zerlege(N) :-
	solve(N,32).

zerlege :-
	zerlege(2),
	zerlege(3),
	zerlege(5),
	zerlege(6),
	zerlege(7),
	zerlege(9),
	zerlege(10),
	zerlege(29),
	zerlege(100).

ziel :-
	leaoff,
	write('Beispiele fuer 2,3,5,6,7,9,10,29,100 ohne LEA Instr.'), nl,
	zerlege,
	leaon,
	write('Beispiele fuer 2,3,5,6,7,9,10,29,100 mit  LEA Instr.'), nl,
	zerlege.
