% $Id: mult-regeln.pl,v 1.2 1996/12/12 07:55:20 uwe Exp $ 

% Problem found in: Sigplan Notices, Vol.30, No.2, Feb.95, Page 42-48 

% increment odd number to get an even number 

rule(Rule,N,N1) :-
	odd(N),
	N1 is N - 1,
	name(N,S),
	name(N1,S1),
	concate(["r", S, " := r", S1, " add r1"], R),
	name(Rule,R).

% decrement odd number to get an even number 

rule(Rule,N,N1) :-
	odd(N),
	N1 is N + 1,
	name(N,S),
	name(N1,S1),
	concate(["r", S," := r", S1, " sub r1"], R),
	name(Rule,R).

% divide even number by largest possible power of 2 

rule(Rule,N,N1) :-
	'n=n1*2^i'(N,N1,I),
	I \== 0,
	name(N,S),
	name(N1,S1),
	name(I,S2),
	concate(["r", S, " := r", S1, " shift ", S2], R),
	name(Rule,R).

% find power of 2 with n = n1 * (2^i + 1) 
% for instruction lea reg,reg,i 
% lea r1,r2,i : r1 + r2 * 2^i 
% on Intel 486: i = 0,1,2,3 

rule(Rule,N,N1) :-
	machinepowers(M),
	member(I,M),
	'n=n1*(2^i+1)'(N,N1,I),
	I \== 0,
	name(N,S),
	name(N1,S1),
	name(I,S2),
	concate(["r", S, " := lea r", S1, ",r", S1, ",", S2], R),
	name(Rule,R).

odd(N) :-
	N mod 2 =:= 1.

even(N) :-
	N mod 2 =:= 0.

power2(0,1) :-
	!.

power2(I,P) :-
	I1 is I - 1,
	power2(I1,P1),
	P is 2 * P1.

'n=n1*2^i'(N,N,0) :-
	odd(N).

'n=n1*2^i'(N,N1,I) :-
	even(N),
	N2 is N // 2,
	'n=n1*2^i'(N2,N1,I2),
	I is I2 + 1.

'n=n1*(2^i+1)'(N,N1,I) :-
	power2(I,P),
	P1 is P + 1,
	N mod P1 =:= 0,
	N1 is N // P1.

%--- Loesung -------------------------------------------------------------------------

solution(1).

%--- Ausgabe -------------------------------------------------------------------------

outstate(_).

outrule(R) :-
	write(R),
	nl.

%-------------------------------------------------------------------------------------
