% $Id: puzzle9-kosten.pl,v 1.1 1995/11/29 16:01:03 uwe Exp $ 
%  Kostenfuntionen und Heuristiken fuer das 9-Puzzle 

:- assertz((help :-
	write('Kostenfunktionen und Heuristiken fuer das 9-Puzzle'), nl,
	write('  breitensuche.	-> g(n) =  1, g(n) = 0'), nl,
	write('  tiefensuche.	-> g(n) = -1, h(n) = 0'), nl,
        write('  bestensuche.	-> g(n) =  0, h(n) = # falscher Steine'), nl,
	write('  bestensuche1.	-> g(n) =  1, h(n) = 10 * # falscher Steine'), nl,
	write('  kurzewege.	-> g(n) =  0, h(n) = Summe der Entfernungen zum richtigen Platz'), nl,
	write('Voreinstellung: breitensuche'), nl,
	nl, fail)
	).

bestensuche :-
	kostenkonstant(0),
	setrule(guess(_,_),
		(guess((_ + L) :-> _, C) :- wrongpos(1, L, C))
	).

bestensuche1 :-
	kostenkonstant(1),
	setrule(guess(_,_),
		(guess((_ + L) :-> _, C) :-
			wrongpos(1, L, C1),
			C is C1 * 10)
	).

kurzewege :-
	kostenkonstant(0),
	setrule(guess(_,_),
		(guess((_ + L) :-> _, C) :- distance(1, L, C))
	).

%-------------------------------------------------------------------------------------

wrongpos(_,[],9).

wrongpos(I,[I|R],N) :-
	!,
	I1 is I + 1,
	wrongpos(I1,R,N1),
	N is N1 - 1.

wrongpos(I,[_|R],N) :-
	I1 is I + 1,
	wrongpos(I1,R,N).

distance(_,[],0).

distance(I,[J|R],N) :-
	I1 is I + 1,
	distance(I1,R,N1),
	dist(I,J,N0),
	N is N1 + N0.

dist(_,'-',0) :-
	!.

dist(I,J,N) :-
	II is I - 1,
	JJ is J - 1,
	I0 is II mod 3,
	I1 is II // 3,
	J0 is JJ mod 3,
	J1 is JJ // 3,
	di(I0,J0,N0),
	di(I1,J1,N1),
	N is N0 + N1.

di(I,J,N) :-
	I >= J,
	!,
	N is I - J.
di(I,J,N) :-
	N is J - I.
  
