% $Id: puzzle9-regeln.pl,v 1.2 1996/12/12 07:55:20 uwe Exp $ 
% Problemdefinition 9-Puzzle 

% --- problemspezifische Bereiche und Praedikate -------------------------------------

/* Zustand : i+[i1,...,'-',...,i9]
                        ^
                        i-te Stelle

   ein Zustand ist ein Paar i+l,
   l ist eine Liste mit 9 Elementen,
   die gerade eine Permutation der Zahlen 1 bis 8 und '-' sind
   und i zeigt auf die Position des '-'.

   i ist redundant, ermoeglicht aber den schellen Test
   auf Anwendbarkeit einer Regel. 	

   '-' spielt die Rolle des Lochs.

   die 'sel' und 'chg' Praedikate und die Listendarstellung sind
   sehr speicherineffizient, hier koennen
   eingebaute arrays oder Vektoren viel schneller sein
*/

%--- Feldzugriffe --------------------------------------------------------------------

sel([Z | _], 1, Z) :-
	!.

sel([_ | R], I, Z) :-
	I1 is I -1,
	sel(R,I1,Z).
  
chg([_ | R], 1, Z, [Z | R]) :-
	!.

chg([Z1 | R], I, Z, [Z1 | R1]) :-
	I1 is I - 1,
	chg(R, I1, Z, R1).
  
ziehe(B, I, J, B1) :-
	sel(B, J, Z),
	chg(B, I, Z, B0),
	chg(B0, J, '-', B1).

%--- die 4 Regeln --------------------------------------------------------------------

rule('nach rechts', I+B, J+B1) :-
	0 =\= I mod 3,
	J is I + 1,
	ziehe(B,I,J,B1).
 
rule('nach links',I+B,J+B1) :- 
	1 =\= I mod 3,
	J is I - 1,
	ziehe(B,I,J,B1).
 
rule('nach oben',I+B,J+B1) :-
	I > 3,
	J is I - 3,
	ziehe(B,I,J,B1).
      
rule('nach unten',I+B,J+B1) :-
	I < 7,
	J is I + 3,
	ziehe(B,I,J,B1).
      
 
%--- die Loesungsmenge als Praedikat -------------------------------------------------

solution(9+[1,2,3,4,5,6,7,8,'-']).

%--- Ausgabe -------------------------------------------------------------------------

outstate(_+Y) :-
	write(Y).

outrule(R) :-
	write(' --> ('),write(R),write(') '),nl.

%-------------------------------------------------------------------------------------
