/* $Id: rat.pl,v 1.2 1996/12/12 07:55:20 uwe Exp $ */
/* rational arithmetic */
/* := as is oprator */
/* ge gr eq as comparison operators */

Z := (X1/Y1) * (X2/Y2) :-
	!,
	X is X1 * X2,
	Y is Y1 * Y2,
	normalize(X/Y,Z).

Z := R1 * (X2/Y2) :-
	integer(R1),
	!,
	X20 is R1 * X2,
	normalize(X20/Y2,Z).

Z := X1/Y1 * R2 :-
	integer(R2),
	!,
	X10 is X1 * R2,
	normalize(X10/Y1,Z).

Z := R1 * R2 :-
	integer(R1),
	integer(R2),
	!,
	R is R1 * R2,
	normalize(R / 1,Z).

Z := R1 / (X1/X2) :-
	!,
	Z := R1 * (X2/X1).

Z := R1 / R2 :-
	integer(R2),
	!,
	Z := R1 * (1 / R2).

Z := (X1/Y1) + (X2/Y2) :-
	!,
	Y is Y1 * Y2,
	X is X1 * Y2 + X2 * Y1,
	normalize(X/Y,Z).

Z := R1 + R2 :-
	integer(R1),
	!,
	Z := R1 / 1 + R2.

Z := R1 + R2 :-
	integer(R2),
	!,
	Z := R1 + R2 / 1.

Z := R - (X2/Y2) :-
	!,
	X20 is (0 - X2),
	Z := R + (X20/Y2).

Z := R - R2 :-
	integer(R2),
	!,
	Z := R - ( R2 / 1 ).

Z1 ge Z2 :-
	Z := Z1 - Z2,
	positive(Z).

Z1 eq Z2 :-
	0 := Z1 - Z2.

Z1 gr Z2 :-
	Z := Z1 - Z2,
	Z \= 0,
	positive(Z).


positive(Z) :-
	integer(Z),
	!,
	Z >= 0.

positive(X/_) :-
	X >= 0.

normalize(0 / _,0) :- !.

normalize(X / 1,X) :- !.

normalize(X/Y,Z) :-
	ggt(X,Y,G),
	G \== 1,
	!,
	X1 is X // G,
	Y1 is Y // G,
	normalize(X1/Y1,Z).

normalize(Z,Z).

ggt(X,Y,G) :-
	X < 0,
	X1 is 0 - X,
	ggt(X1,Y,G),
	!.

ggt(X,Y,G) :-
	Y < 0,
	Y1 is 0 - Y,
	ggt(X,Y1,G),
	!.

ggt(X,Y,Y) :-
	0 is X mod Y,
	!.

ggt(X,Y,G) :-
	X > Y,
	X1 is X mod Y,
	ggt(Y,X1,G),
	!.

ggt(X,Y,G) :-
	X < Y,
	ggt(Y,X,G),
	!.

numerator(X,X) :-
	integer(X),
	!.

numerator(X/_,X).

denominator(X,1) :-
	integer(X),
	!.

denominator(_/X,X).

tofloat(X,X) :-
	integer(X),
	!.

tofloat(X/Y,R) :-
	R is X / Y.
		
